import { createAction, props } from '@ngrx/store';
import {
  InfoRequest,
  RoomInfo,
  UserInfoShort,
  UserInfo,
  InviteNotification,
  ExitNotification,
  ExitForcingNotification,
  UpdateFontNotification
} from '@ucap-webmessenger/protocol-room';

export const info = createAction(
  '[Messenger::Room] Info',
  props<InfoRequest>()
);

export const infoSuccess = createAction(
  '[Messenger::Room] Info Success',
  props<{
    roomInfo: RoomInfo;
    userInfoShortList: UserInfoShort[];
    userInfoList: UserInfo[];
  }>()
);

export const infoFailure = createAction(
  '[Messenger::Room] Info Failure',
  props<{ error: any }>()
);

export const inviteNotification = createAction(
  '[Messenger::Room] Invite Notification',
  props<{ noti: InviteNotification }>()
);

export const exitNotification = createAction(
  '[Messenger::Room] Exit Notification',
  props<{ noti: ExitNotification }>()
);

export const exitForcingNotification = createAction(
  '[Messenger::Room]  Exit Forcing Notification',
  props<{ noti: ExitForcingNotification }>()
);

export const updateFontNotification = createAction(
  '[Messenger::Room]  Update Font Notification',
  props<{ noti: UpdateFontNotification }>()
);
